using System; using UnityEngine; using System.Collections; using System.Collections.Generic; using SimpleJSON; using System.Linq; using GPUTools.Hair.Scripts.Settings;  
namespace JayJayWonPlugin
{
    public class BJAssist : MVRScript
    {
        private Atom her; private Atom him ;
        private Rigidbody lipTrigger; private Rigidbody headRigidbody ;private Rigidbody penisBaseRB;
        Dictionary<DAZMorph, float> LipMorphs = new Dictionary<DAZMorph, float>(); Dictionary<DAZMorph, float> TongueOutMorphs = new Dictionary<DAZMorph, float>(); Dictionary<DAZMorph, float> TongueInMorphs = new Dictionary<DAZMorph, float>();
		DAZMorph tongueMorphTwist ; DAZMorph tongueMorphSideSide ; DAZMorph tongueMorphBendTip ;
		private UIDynamicButton startPauseButton ;
        private FreeControllerV3 headControl; private FreeControllerV3 penisTip; private FreeControllerV3 penisBase; private FreeControllerV3 penisMid; 
        private JSONStorableFloat headTiltYJSON; private JSONStorableFloat headTiltXJSON; private JSONStorableFloat positionSuckStart; private JSONStorableFloat positionSuckDepth; private JSONStorableFloat headSuckSpeedJSON; private JSONStorableFloat headMoveToPenisSpeedJSON; private JSONStorableFloat headMoveXAngleJSON; private JSONStorableFloat headMoveYAngleJSON; private JSONStorableFloat headRotateInitialJSON; private JSONStorableFloat headRotateMinMaxJSON; private JSONStorableFloat headRotateSpeedJSON; private JSONStorableFloat headTiltSpeedJSON; private JSONStorableFloat headMoveSpeedJSON; private JSONStorableFloat tongueBendTipJSON; private JSONStorableFloat tongueSideSideJSON; private JSONStorableFloat tongueTwistJSON; private JSONStorableFloat faceGrindFrequencyJSON;private JSONStorableFloat faceGrindDurationJSON;private JSONStorableFloat autoStartDistanceJSON;private JSONStorableFloat autoStopDistanceJSON;private JSONStorableFloat manualAdjustOffset;
		private JSONStorableBool enableLipMorphs;private JSONStorableBool enableFaceGrind ;private JSONStorableBool enableTongueMorphs ;	private JSONStorableBool enablePenisSpring ; private JSONStorableBool enableHeadPenisPhysControl ; private JSONStorableBool enableBJAutoRecover ;private JSONStorableBool enableAutoStart ;
        private Vector3 headInitialPosition;  private Vector3 penisBaseInitialPosition; private Vector3 headMoveTargetPosition; private Vector3 headTargetPosition; private Vector3 headToLipOffset;private Vector3 penisBaseInitialDirection;  private Vector3 penisBaseInitialUpDirection; private Vector3 penisBaseToHeadTargetDirection; private Vector3 penisBaseNextDirection; private Vector3 headOffset; private Vector3 headInitialUp; private Vector3 headCalibrationVector ;
        private Quaternion headInitialRotation; private Quaternion headStartRotation;private Quaternion headTargetRotation; private Quaternion headInitialTargetRotationOffset; private Quaternion headResetRotation; private Quaternion headMoveXOffset; private Quaternion headMoveYOffset; private Quaternion penisBaseStartRotation; private Quaternion penisResetRotation;
        private bool isMovingToPenis = false; private bool isMovingOnToPenis = false; private bool isSuckingOnPenis = false; private bool isSuckingOffPenis = false; private bool isResetting = false;	private bool isSettingPhysics = false; private bool isResettingPhysics = false;	private bool isSettingPausePhysics = false;	private bool isResettingPausePhysics = false; private bool isStarted = false; private bool isPaused = false; private bool isFaceGrindHolding =false ;private bool autoStart =false; private bool tongueMorphsDisabling =false; private bool lipMorphsDisabling =false;
        private float journeyDistance; private float journeyTime; private float morphValue = 0f; private float morphChangeDistance; private float morphChangeSpeed; private float distCovered; private float fracJourney;  private float positionTarget;  private float positionCurrent; private float headZRotationTarget; private float headZRotationLastMinMaxTarget; private float headZRotationCurrent;private float headXTiltNext; private float headYTiltNext; private float headXTiltTarget; private float headYTiltTarget;	private float headRotateMin = 0f; private float headRotateMax = 0f;	private float positionTop ; private float positionBottom ;	private float suckStep; private float moveHeadStep; private float tiltHeadStep ; private float rotateHeadStep;
        private float startTime; private float pauseStartTime = 0; private float faceGrindHoldStartTime; private float lastFaceGrindHoldEndTime; 	
		const float faceGrindDisabled = -0.4f ;	const float faceGrindEnabled = -0.85f ;	const float faceGrindHold =-0.25f; const float minPositionTwo = 0.8f ;	const float TongueMorphIncrement = 0.1f ; const float maxDistanceFromPenis = 0.05f; const float headCalibrationOffset = 0.02f; 
        public override void Init()
        {
            try
            {
		        const string pluginName = "BJAssist";
				const string pluginVersion = "v1.4";
				const string pluginAuthor = "JayJayWon";	
				her = containingAtom;
                headControl = her.freeControllers.First(fc => fc.name == "headControl");
                headRigidbody = her.rigidbodies.First(rb => rb.name == "head");
                lipTrigger = her.rigidbodies.First(rb => rb.name == "LipTrigger");
                // Set target mouth morphs
                JSONStorable geometry = her.GetStorableByID("geometry");
                DAZCharacterSelector character = geometry as DAZCharacterSelector;
                GenerateDAZMorphsControlUI morphControl = character.morphsControlUI;
                DAZMorph dazMorph = morphControl.GetMorphByDisplayName("Lips Pucker");
                if (dazMorph != null)
                {
                    LipMorphs.Add(morphControl.GetMorphByDisplayName("Lips Pucker"), 0.5f);
                    LipMorphs.Add(morphControl.GetMorphByDisplayName("Lips Pucker Wide"), 0.5f);
                    LipMorphs.Add(morphControl.GetMorphByDisplayName("Lips Close"), 0.5f);            
					// Set target tongue Out morphs
                    TongueOutMorphs.Add(morphControl.GetMorphByDisplayName("Tongue In-Out"), -2f);
                    TongueOutMorphs.Add(morphControl.GetMorphByDisplayName("Tongue Length"), 0.2f);
                    TongueOutMorphs.Add(morphControl.GetMorphByDisplayName("Tongue Narrow-Wide"), -2f);                
					// Set target tongue In morphs
                    TongueInMorphs.Add(morphControl.GetMorphByDisplayName("Tongue In-Out"), 1f);
                    TongueInMorphs.Add(morphControl.GetMorphByDisplayName("Tongue Length"), 0f);
                    TongueInMorphs.Add(morphControl.GetMorphByDisplayName("Tongue Narrow-Wide"), -1f);					
					tongueMorphTwist = morphControl.GetMorphByDisplayName("Tongue Twist");
					tongueMorphSideSide = morphControl.GetMorphByDisplayName("Tongue Side-Side");
					tongueMorphBendTip = morphControl.GetMorphByDisplayName("Tongue Bend Tip");
				}            
                // UI Setup
                startPauseButton = CreateButton("Start");
                startPauseButton.button.onClick.AddListener(() => { ToggleBJStart(); });
                JSONStorableAction StartBJAction = new JSONStorableAction("Start BJ", () =>{StartBJMove();});
                RegisterAction(StartBJAction);
                JSONStorableAction PauseBJAction = new JSONStorableAction("Pause BJ", () =>{PauseBJMove();});
                RegisterAction(PauseBJAction);
                JSONStorableAction UnPauseBJAction = new JSONStorableAction("Unpause BJ", () =>{UnPauseBJMove();});
                RegisterAction(UnPauseBJAction);
                JSONStorableAction TogglePauseBJAction = new JSONStorableAction("Toggle BJ Pause", () =>{TogglePauseBJMove();});
                RegisterAction(TogglePauseBJAction);
                JSONStorableAction ResetBJAction = new JSONStorableAction("Reset BJ", () =>{if (isResetting == false) { MoveToPenisTip (); }});
                RegisterAction(ResetBJAction);
                var btn = CreateButton("Stop");
                btn.button.onClick.AddListener(() => { StopBJ(); });
                JSONStorableAction StopBJAction = new JSONStorableAction("Stop BJ", () => {StopBJ();});
                RegisterAction(StopBJAction);		
                autoStartDistanceJSON = new JSONStorableFloat("Auto Start Distance", 0f, 0f, 10f, false);
//                RegisterFloat(autoStartDistanceJSON);
//                CreateSlider(autoStartDistanceJSON);
                autoStopDistanceJSON = new JSONStorableFloat("Auto Stop Distance", 0f, 0f, 10f, false);
//                RegisterFloat(autoStopDistanceJSON);
//                CreateSlider(autoStopDistanceJSON);			
                enableAutoStart = new JSONStorableBool("Enable Auto Start on Scene Load", false);
                enableAutoStart.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableAutoStart);
                var asToggle = CreateToggle(enableAutoStart);
				headMoveToPenisSpeedJSON = new JSONStorableFloat("Initial Move Speed", 0.35f, 0f, 1f, false);
                headMoveToPenisSpeedJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headMoveToPenisSpeedJSON);
                CreateSlider(headMoveToPenisSpeedJSON);
                headSuckSpeedJSON = new JSONStorableFloat("Suck Speed", 0.35f, 0f, 1f, false);
                headSuckSpeedJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headSuckSpeedJSON);
                CreateSlider(headSuckSpeedJSON);
                positionSuckStart = new JSONStorableFloat("Suck Start Postition", 0.2f, -1f, 1f);
                positionSuckStart.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(positionSuckStart);
                CreateSlider(positionSuckStart);
                positionSuckDepth = new JSONStorableFloat("Suck Depth", 0.5f, 0f, 3f, false);
                positionSuckDepth.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(positionSuckDepth);
                CreateSlider(positionSuckDepth);				
                enableFaceGrind = new JSONStorableBool("Enable Face Grinding", false);
                enableFaceGrind.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableFaceGrind);
                var fgToggle = CreateToggle(enableFaceGrind);
                faceGrindFrequencyJSON = new JSONStorableFloat("Face Grind Hold Interval (seconds)", 10f, 0f, 120f,false);
                faceGrindFrequencyJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(faceGrindFrequencyJSON);
                CreateSlider(faceGrindFrequencyJSON);
                faceGrindDurationJSON = new JSONStorableFloat("Face Grind Hold Duration (seconds)", 2f, 0f, 10f,false);
                faceGrindDurationJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(faceGrindDurationJSON);
                CreateSlider(faceGrindDurationJSON);		
                enableLipMorphs = new JSONStorableBool("Enable Lip Morphs", false);
                enableLipMorphs.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableLipMorphs);
                var lmToggle = CreateToggle(enableLipMorphs);				
                lmToggle.toggle.onValueChanged.AddListener(delegate { ToggleLipMorphs(); });
                enableTongueMorphs = new JSONStorableBool("Enable Tongue Morphs", false);
                enableTongueMorphs.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableTongueMorphs);
                var tmToggle = CreateToggle(enableTongueMorphs);
                tmToggle.toggle.onValueChanged.AddListener(delegate { ToggleTongueMorphs(); });
                tongueBendTipJSON = new JSONStorableFloat("Tongue Bend Tip", 0f, -1f, 1f);
                tongueBendTipJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(tongueBendTipJSON);
                tongueSideSideJSON = new JSONStorableFloat("Tongue Side-Side", 0f, -1f, 1f);
                tongueSideSideJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(tongueSideSideJSON);
                tongueTwistJSON = new JSONStorableFloat("Tongue Twist", 0f, -1f, 1f);
                tongueTwistJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(tongueTwistJSON);
                enablePenisSpring = new JSONStorableBool("Enable Penis Spring", true);
                enablePenisSpring.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enablePenisSpring);
                var psToggle = CreateToggle(enablePenisSpring);
                headMoveSpeedJSON = new JSONStorableFloat("Head Move Speed", 1f, 0f, 5f,false);
                headMoveSpeedJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headMoveSpeedJSON);
                CreateSlider(headMoveSpeedJSON, true);
                headMoveXAngleJSON = new JSONStorableFloat("Head Move Down/Up Angle", 0f, -90f, 90f);
                headMoveXAngleJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headMoveXAngleJSON);
                CreateSlider(headMoveXAngleJSON, true);
                headMoveYAngleJSON = new JSONStorableFloat("Head Move Left/Right Angle", 0f, -90f, 90f);
                headMoveYAngleJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headMoveYAngleJSON);
                CreateSlider(headMoveYAngleJSON, true);				
                headTiltSpeedJSON = new JSONStorableFloat("Head Tilt Speed", 1f, 0f, 5f);
                headTiltSpeedJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headTiltSpeedJSON);
                CreateSlider(headTiltSpeedJSON, true);
				headTiltXJSON = new JSONStorableFloat("Head Tilt Angle Down/Up", -20f, -45f, 45f, false);
                headTiltXJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headTiltXJSON);
                CreateSlider(headTiltXJSON, true);
                headTiltYJSON = new JSONStorableFloat("Head Tilt Angle Left/Right", 0f, -45f, 45f, false);
                headTiltYJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headTiltYJSON);
                CreateSlider(headTiltYJSON, true);
                headRotateSpeedJSON = new JSONStorableFloat("Head Rotate Speed", 1f, 0f, 10f,false);
                headRotateSpeedJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headRotateSpeedJSON);
                CreateSlider(headRotateSpeedJSON, true);
                headRotateInitialJSON = new JSONStorableFloat("Head Rotate Initial Angle", 0f, -180f, 180f);
                headRotateInitialJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headRotateInitialJSON);
                CreateSlider(headRotateInitialJSON, true);
                headRotateMinMaxJSON = new JSONStorableFloat("Head Rotate +/- Angle Offset", 0f, 0f, 90f,false);
                headRotateMinMaxJSON.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(headRotateMinMaxJSON);
                CreateSlider(headRotateMinMaxJSON, true);
                enableHeadPenisPhysControl = new JSONStorableBool("Control Head & Penis Physics Control", true);
                enableHeadPenisPhysControl.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableHeadPenisPhysControl);
                var pcToggle = CreateToggle(enableHeadPenisPhysControl,true);
                pcToggle.toggle.onValueChanged.AddListener(delegate { TogglePhysicsControl(); });		
                enableBJAutoRecover = new JSONStorableBool("Enable Auto Recover", true);
                enableBJAutoRecover.storeType = JSONStorableParam.StoreType.Physical;
                RegisterBool(enableBJAutoRecover);
                var arToggle = CreateToggle(enableBJAutoRecover);						 
                manualAdjustOffset = new JSONStorableFloat("Manual Head Offset adjustment", 0f, -2f, 2f,false);
                manualAdjustOffset.storeType = JSONStorableParam.StoreType.Physical;
                RegisterFloat(manualAdjustOffset);
                CreateSlider(manualAdjustOffset, true);
                var versionLabel = CreateTextField(new JSONStorableString("", ""));
				versionLabel.text = pluginName + " " + pluginVersion +"\n"+"by "+pluginAuthor;
				versionLabel.height =10;
			}
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }	
        }

        // Start is called once before Update or FixedUpdate is called and after Init()
        void Start()
        {
            try{
				if (enableAutoStart.val==true) {autoStart=true;} 
				else {autoStart=false;}
			}
            catch (Exception e){SuperController.LogError("Exception caught in Start(): " + e);}
        }
		
        // Update is called with each rendered frame by Unity
        void Update()
        {
            try{}
            catch (Exception e){SuperController.LogError("Exception caught: " + e);}
        }

        // FixedUpdate is called with each physics simulation frame by Unity
        void FixedUpdate()
        {
          try
            {
				if (autoStart && isStarted == false){StartBJMove(); autoStart=false;}
				if (SuperController.singleton.freezeAnimation == false){
					headCalibrationVector = Quaternion.AngleAxis(headRotateInitialJSON.val,lipTrigger.transform.forward) * lipTrigger.transform.up * headCalibrationOffset * (1f+manualAdjustOffset.val) ;
					SetHeadToLipOffset();
					if (isMovingToPenis && isPaused == false){MovingToPenisUpdate ();}
					if (isMovingOnToPenis && isPaused == false){MovingOnToPenisUpdate ();}
					if (isSuckingOffPenis && isPaused == false){SuckingOffPenisUpdate ();}
					if (isSuckingOnPenis && isPaused == false){SuckingOnPenisUpdate ();}
					if (isResetting && isPaused == false){ResettingUpdate ();}
					if (isSuckingOnPenis == false)
					{
						if (enableTongueMorphs.val) {tongueMorphTwist.morphValue = 0f ;	tongueMorphSideSide.morphValue = 0f ; tongueMorphBendTip.morphValue = 0f ;}
					}
					if (isSettingPhysics && isPaused == false){SetPhysics();}
					if (isResettingPhysics && isPaused == false){ResetPhysics();}
					if (isSettingPausePhysics && isPaused){SetPausePhysics ();}
					if (isResettingPausePhysics){ResetPausePhysics ();}
		/*			if (isStarted == false && autoStartDistanceJSON.val > 0)
					{
						float distanceOff ;
						distanceOff = Vector3.Distance (penisTip.transform.position, lipTrigger.transform.position);
						if (distanceOff < autoStartDistanceJSON.val )
						{
							autoStartDistanceJSON.val = autoStartDistanceJSON.val - 0.1f;
							StartBJMove();
						}
					}
					if (isStarted && autoStopDistanceJSON.val > 0 && isMovingToPenis == false && isResetting == false)
					{
						float distanceOff ;
						distanceOff = DistanceToNearestPointOnFiniteLine(penisMid.transform.position-(penisBaseNextDirection * (positionTop)),penisMid.transform.position+(penisBaseNextDirection * (positionTop/2)),lipTrigger.transform.position);;					
						if (distanceOff > autoStopDistanceJSON.val && distanceOff > maxDistanceFromPenis)
						{
							StopBJ();
						}
					}*/	
				}
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }	
		private bool physicsValuesAtTarget = false ;
		private FreeControllerV3.PositionState initPBPosState ; private FreeControllerV3.RotationState initPBRotState ; private FreeControllerV3.PositionState initPMPosState ; private FreeControllerV3.RotationState initPMRotState ;	private FreeControllerV3.PositionState initPTPosState ;	private FreeControllerV3.RotationState initPTRotState ;	private FreeControllerV3.PositionState initHeadPosState ; private FreeControllerV3.RotationState initHeadRotState ;
		private float initPBHoldPosSpring ; private float initPBHoldRotSpring ; private float initPBHoldPosDamper ;	private float initPBHoldRotDamper ;	private float initPBHoldPosMaxForce ; private float initPBHoldRotMaxForce ;	private float initPBJointRotSpring ;private float initPBJointRotDamper ;private float initPBJointRotMaxForce ;private float initPMJointRotSpring ;private float initPMJointRotDamper ; private float initPMJointRotMaxForce ; private float initPTJointRotSpring ;	private float initPTJointRotDamper ;private float initPTJointRotMaxForce ; private float initHeadHoldPosSpring ; private float initHeadHoldRotSpring ;	private float initHeadHoldPosDamper ;private float initHeadHoldRotDamper ;	private float initHeadHoldPosMaxForce ;	private float initHeadHoldRotMaxForce ;
		private void MovingToPenisUpdate ()
		{
			// Move head to start position
			float moveStep = headMoveToPenisSpeedJSON.val * Time.deltaTime;
			headControl.transform.position = Vector3.MoveTowards(headControl.transform.position, headMoveTargetPosition + headToLipOffset + headCalibrationVector, moveStep)  ;
			LipMorphsReset();
			TongueMorphsReset();			
			//  Slowly rotate head;
			float rotateSpeed = (journeyDistance / journeyTime) ;
			distCovered = (Time.time - startTime) * rotateSpeed;
			fracJourney = distCovered / journeyDistance;
			headControl.transform.rotation = Quaternion.Lerp(headStartRotation, headTargetRotation, fracJourney);
			// Set the Target & Next direction of the penis base to head vector				
			penisBaseToHeadTargetDirection = penisBaseInitialDirection;
			penisBaseNextDirection = Vector3.RotateTowards(penisBaseNextDirection, penisBaseToHeadTargetDirection, moveHeadStep, 0.0f) ; 			
			// Gradually rotate the penis towards the target direction
			penisBase.transform.LookAt(penisBaseInitialPosition + penisBaseNextDirection , penisBaseInitialUpDirection);
			// If finished, move on to penis
			if (Vector3.Distance(headControl.transform.position - headToLipOffset - headCalibrationVector, headMoveTargetPosition) < 0.001f && physicsValuesAtTarget)
			{
				MoveOnToPenis();
			}
		}
		
		private void MovingOnToPenisUpdate ()
		{
			float moveStep = headMoveToPenisSpeedJSON.val * Time.deltaTime;
			headControl.transform.position = Vector3.MoveTowards(headControl.transform.position, headMoveTargetPosition + headToLipOffset+ headCalibrationVector, moveStep)  ;

			// Set the Target & Next direction of the penis base to head vector				
			penisBaseToHeadTargetDirection = penisBaseInitialDirection;
			penisBaseNextDirection = Vector3.RotateTowards(penisBaseNextDirection, penisBaseToHeadTargetDirection, moveHeadStep, 0.0f) ; 
			
			// Gradually rotate the penis towards the target direction
			penisBase.transform.LookAt(penisBaseInitialPosition + penisBaseNextDirection , penisBaseInitialUpDirection);

			// Slowly add lips morphs
			if (enableLipMorphs.val)
			{
				foreach (KeyValuePair<DAZMorph, float> morphPair in LipMorphs)
				{
					morphChangeDistance = morphPair.Value;
					morphChangeSpeed = morphChangeDistance / journeyTime * 1f;
					distCovered = (Time.time - startTime) * morphChangeSpeed;
					fracJourney = distCovered / morphChangeDistance;
					morphPair.Key.morphValue = Mathf.Lerp(0f, morphPair.Value, fracJourney);
				}
			}
			// If finished, start sucking
			if (Vector3.Distance(headControl.transform.position - headToLipOffset- headCalibrationVector, headMoveTargetPosition) < 0.001f)
			{
				StartSucking();
			}
		}
		
		private void SuckingOffPenisUpdate ()
		{
			SetSuckPositionsAndSpeed () ;
			UpdateHeadMoveSpeeds () ;
			// Because we are off penis, overide the head rotation and tilt targets to be zero
			headZRotationTarget = 0 ; headYTiltTarget = 0; headXTiltTarget = 0;					
			UpdateHeadTiltAndRotation () ;         
			
			// Set the Target & Next direction of the penis base to head vector				
			if (enablePenisSpring.val)
			{
				penisBaseToHeadTargetDirection = penisBaseInitialDirection;
				penisBaseNextDirection = Vector3.RotateTowards(penisBaseNextDirection, penisBaseToHeadTargetDirection, moveHeadStep, 0.0f) ;
			}					
			LipMorphsReset();
			TongueMorphsReset();
			UpdatePenisHeadRotPos();			
			// Establish if the head has moved onto the end of the penis 
			if (Vector3.Distance (penisBase.transform.position,penisTip.transform.position)+0.00f > Vector3.Distance (penisBase.transform.position, lipTrigger.transform.position))
			{
				isSuckingOnPenis = true ;
				isSuckingOffPenis = false ;
			}			
		}
		
		private void SuckingOnPenisUpdate ()
		{
			SetSuckPositionsAndSpeed () ;
			UpdateHeadRotationTargets ();
			UpdateHeadMoveSpeeds () ;
			headMoveXOffset = Quaternion.AngleAxis(headMoveXAngleJSON.val, Quaternion.AngleAxis(-90, penisBaseInitialUpDirection) * penisBaseInitialDirection);
			headMoveYOffset = Quaternion.AngleAxis(headMoveYAngleJSON.val, penisBaseInitialUpDirection);
			if (isFaceGrindHolding || positionCurrent <= faceGrindHold)
			{
				headYTiltTarget =0f;
				penisBaseToHeadTargetDirection = penisBaseInitialDirection ;
			}
			else
			{
				headYTiltTarget = headTiltYJSON.val;
				penisBaseToHeadTargetDirection = headMoveXOffset * headMoveYOffset * penisBaseInitialDirection;
			}
			headXTiltTarget = headTiltXJSON.val;
					
			UpdateHeadTiltAndRotation () ;		
			// Set the Target & Next direction of the penis base to head vector			
			penisBaseNextDirection = Vector3.RotateTowards(penisBaseNextDirection, penisBaseToHeadTargetDirection, moveHeadStep, 0.0f) ; 
			UpdatePenisHeadRotPos ();			
			if (enableLipMorphs.val) {LipMorphsEnable();}
			else { LipMorphsReset ();}			
			if (enableTongueMorphs.val) 
			{
				TongueMorphsEnable();
				tongueMorphTwist.morphValue = tongueTwistJSON.val ;
				tongueMorphSideSide.morphValue = tongueSideSideJSON.val ;
				tongueMorphBendTip.morphValue = tongueBendTipJSON.val ;						
			}
			else{TongueMorphsReset();}
			// Establish if the head has moved off the end of the penis 
			if (Vector3.Distance (penisBase.transform.position,penisTip.transform.position)+0.08f < Vector3.Distance (penisBase.transform.position, lipTrigger.transform.position))
			{
				isSuckingOnPenis = false ;
				isSuckingOffPenis = true ;
				journeyDistance = Vector3.Distance(lipTrigger.transform.position, penisBaseInitialPosition + (penisBaseNextDirection * positionTop) + headToLipOffset) *2f;
				journeyTime = journeyDistance / headSuckSpeedJSON.val;
				startTime = Time.time;
			}
			float distanceOff1 ;
			float distanceOff2 ;
			float distanceMin ;
			distanceOff1 = DistanceToNearestPointOnFiniteLine(penisBase.transform.position-(penisBaseNextDirection * 0.5f),penisMid.transform.position,lipTrigger.transform.position);
			distanceOff2 = DistanceToNearestPointOnFiniteLine(penisTip.transform.position+(penisTip.transform.forward * 0.1f),penisMid.transform.position,lipTrigger.transform.position);
			distanceMin = Mathf.Min (distanceOff1,distanceOff2) ;
			if (distanceMin > maxDistanceFromPenis && positionTarget < 1.5f && enableBJAutoRecover.val)
			{
				MoveToPenisTip () ;
				SuperController.LogMessage("Auto Resetting BJ" );
			}		
		}
		
		private void ResettingUpdate ()
		{
			// Slowly reset head position
			float moveStep = headMoveToPenisSpeedJSON.val * Time.deltaTime;
			headControl.transform.position = Vector3.MoveTowards(headControl.transform.position, headInitialPosition, moveStep);
			// Slowly reset lip & tongue morphs
			LipMorphsReset ();
			TongueMorphsReset();		
			//  Slowly reset head and penis rotation;
			float rotateSpeed = (journeyDistance / journeyTime);
			distCovered = (Time.time - startTime) * rotateSpeed;
			fracJourney = distCovered / journeyDistance;
			headControl.transform.rotation = Quaternion.Slerp(headResetRotation, headInitialRotation, fracJourney);
			penisBase.transform.rotation = Quaternion.Slerp(penisResetRotation, penisBaseStartRotation, fracJourney);
			// Check if head is back to start point
			if (Vector3.Distance(headControl.transform.position, headInitialPosition) < 0.001f && isResettingPhysics == false)
			{
				isResetting = false;
				isStarted = false;
				isPaused = false;
				startPauseButton.buttonText.text = "Start" ;
				penisBase.currentPositionState = initPBPosState;
				penisBase.currentRotationState = initPBRotState ;
				penisMid.currentPositionState = initPMPosState ;
				penisMid.currentRotationState = initPMRotState ;
				penisTip.currentPositionState = initPTPosState ;
				penisTip.currentRotationState = initPTRotState ;
				headControl.currentPositionState = initHeadPosState;
				headControl.currentRotationState = initHeadRotState ;
			}
		}
		
		private void UpdatePenisHeadRotPos ()
		{
			// Gradually rotate the penis towards the target direction
			penisBase.transform.LookAt(penisBaseInitialPosition + penisBaseNextDirection , penisBaseInitialUpDirection);
			// Gradually move head towards the target postion 
			headControl.transform.position = penisBaseInitialPosition + (penisBaseNextDirection * positionCurrent) + headToLipOffset + headCalibrationVector;								
			// Set the head rotation to look at the inverse of the penis base to head direction
			headControl.transform.rotation = Quaternion.LookRotation(- penisBaseNextDirection, penisBaseInitialUpDirection) ;	
			// Offset the head rotation and tilt as per UI settings
			headControl.transform.Rotate (headXTiltNext,headYTiltNext,headRotateInitialJSON.val + headZRotationCurrent) ;		
		}
		private void TogglePhysicsControl ()
		{
			if (isStarted)
			{
				if (enableHeadPenisPhysControl.val)
				{
					isSettingPhysics = true ;
					isResettingPhysics = false;
					isResettingPausePhysics = false;
				}
				else
				{
					isSettingPhysics = false ;
					isResettingPhysics = true ;
					isResettingPausePhysics = false ;					
				}
			}
		}
		
		private void SetPhysics()
		{		
			physicsValuesAtTarget = true ;			
			penisBase.RBHoldPositionSpring = SlideValue(penisBase.RBHoldPositionSpring,30000,500);
            penisBase.RBHoldRotationSpring = SlideValue(penisBase.RBHoldRotationSpring,1000,50);
            penisBase.RBHoldPositionDamper = SlideValue(penisBase.RBHoldPositionDamper,100,5);
            penisBase.RBHoldRotationDamper = SlideValue(penisBase.RBHoldRotationDamper,100,5);
            penisBase.RBHoldPositionMaxForce = SlideValue(penisBase.RBHoldPositionMaxForce,10000,500);
            penisBase.RBHoldRotationMaxForce = SlideValue(penisBase.RBHoldRotationMaxForce,1000,50);
            penisBase.jointRotationDriveSpring = SlideValue(penisBase.jointRotationDriveSpring,200,5);
            penisBase.jointRotationDriveDamper = SlideValue(penisBase.jointRotationDriveDamper,10,1);
            penisBase.jointRotationDriveMaxForce = SlideValue(penisBase.jointRotationDriveMaxForce,100,5);
            penisMid.jointRotationDriveSpring = SlideValue(penisMid.jointRotationDriveSpring,200,5);
            penisMid.jointRotationDriveDamper = SlideValue(penisMid.jointRotationDriveDamper,10,1);
            penisMid.jointRotationDriveMaxForce = SlideValue(penisMid.jointRotationDriveMaxForce,100,5);
            penisTip.jointRotationDriveSpring = SlideValue(penisTip.jointRotationDriveSpring,200,5);
            penisTip.jointRotationDriveDamper = SlideValue(penisTip.jointRotationDriveDamper,10,1);
            penisTip.jointRotationDriveMaxForce = SlideValue(penisTip.jointRotationDriveMaxForce,100,5); 
			headControl.RBHoldPositionSpring = SlideValue(headControl.RBHoldPositionSpring,3000000,500000);
			headControl.RBHoldPositionDamper = SlideValue(headControl.RBHoldPositionDamper,2000,100);
			headControl.RBHoldPositionMaxForce = SlideValue(headControl.RBHoldPositionMaxForce,10000000,500000);
			headControl.RBHoldRotationSpring = SlideValue(headControl.RBHoldRotationSpring,10000000,500000);
			headControl.RBHoldRotationDamper = SlideValue(headControl.RBHoldRotationDamper,5,1);
			headControl.RBHoldRotationMaxForce = SlideValue(headControl.RBHoldRotationMaxForce,10000000,500000);			
			if ( physicsValuesAtTarget == true ) 
			{
				if (isMovingToPenis)
				{
					// If the physics have all been set on the penis and we are moving to penis (ie. just starting) then capture initial penis position and rotation
					penisBaseInitialPosition = penisBase.transform.position;
					penisBaseInitialUpDirection = penisBase.transform.up; 
					penisBaseInitialDirection = penisTip.transform.position - penisBase.transform.position;
					penisBaseToHeadTargetDirection = penisBaseInitialDirection ;
					headMoveTargetPosition = penisBaseInitialPosition + (penisBaseInitialDirection * 2.5f) ;
				}
				isSettingPhysics = false;
			}		 
		}

		private void SetPausePhysics()
		{
			physicsValuesAtTarget = true ;			
			headControl.RBHoldPositionSpring = SlideValue(headControl.RBHoldPositionSpring,4000,1000);
			headControl.RBHoldPositionDamper = SlideValue(headControl.RBHoldPositionDamper,35,100);
			if ( physicsValuesAtTarget == true )
			{
				isSettingPausePhysics = false;
			}
		}

		private void ResetPausePhysics()
		{			
			physicsValuesAtTarget = true ;			
			headControl.RBHoldPositionSpring = SlideValue(headControl.RBHoldPositionSpring,300000000,10000000);
			headControl.RBHoldPositionDamper = SlideValue(headControl.RBHoldPositionDamper,2000,100);
			if ( physicsValuesAtTarget == true )
			{
				isResettingPausePhysics = false;
			}
		}

		private void ResetPhysics()
		{
            physicsValuesAtTarget = true ;			
			penisBase.RBHoldPositionSpring = SlideValue(penisBase.RBHoldPositionSpring,initPBHoldPosSpring,500);
            penisBase.RBHoldRotationSpring = SlideValue(penisBase.RBHoldRotationSpring,initPBHoldRotSpring,50);
            penisBase.RBHoldPositionDamper = SlideValue(penisBase.RBHoldPositionDamper,initPBHoldPosDamper,5);
            penisBase.RBHoldRotationDamper = SlideValue(penisBase.RBHoldRotationDamper,initPBHoldRotDamper,5);
            penisBase.RBHoldPositionMaxForce = SlideValue(penisBase.RBHoldPositionMaxForce,initPBHoldPosMaxForce,500);
            penisBase.RBHoldRotationMaxForce = SlideValue(penisBase.RBHoldRotationMaxForce,initPBHoldRotMaxForce,50);
            penisBase.jointRotationDriveSpring = SlideValue(penisBase.jointRotationDriveSpring,initPBJointRotSpring,5);
            penisBase.jointRotationDriveDamper = SlideValue(penisBase.jointRotationDriveDamper,initPBJointRotDamper,1);
            penisBase.jointRotationDriveMaxForce = SlideValue(penisBase.jointRotationDriveMaxForce,initPBJointRotMaxForce,5);
            penisMid.jointRotationDriveSpring = SlideValue(penisMid.jointRotationDriveSpring,initPMJointRotSpring,5);
            penisMid.jointRotationDriveDamper = SlideValue(penisMid.jointRotationDriveDamper,initPMJointRotDamper,1);
            penisMid.jointRotationDriveMaxForce = SlideValue(penisMid.jointRotationDriveMaxForce,initPMJointRotMaxForce,5);
            penisTip.jointRotationDriveSpring = SlideValue(penisTip.jointRotationDriveSpring,initPTJointRotSpring,5);
            penisTip.jointRotationDriveDamper = SlideValue(penisTip.jointRotationDriveDamper,initPTJointRotDamper,1);
            penisTip.jointRotationDriveMaxForce = SlideValue(penisTip.jointRotationDriveMaxForce,initPTJointRotMaxForce,5); 
			headControl.RBHoldPositionSpring = SlideValue(headControl.RBHoldPositionSpring,initHeadHoldPosSpring,500000);
			headControl.RBHoldPositionDamper = SlideValue(headControl.RBHoldPositionDamper,initHeadHoldPosDamper,100);
			headControl.RBHoldPositionMaxForce = SlideValue(headControl.RBHoldPositionMaxForce,initHeadHoldPosMaxForce,500000);
			headControl.RBHoldRotationSpring = SlideValue(headControl.RBHoldRotationSpring,initHeadHoldRotSpring,500000);
			headControl.RBHoldRotationDamper = SlideValue(headControl.RBHoldRotationDamper,initHeadHoldRotDamper,1);
			headControl.RBHoldRotationMaxForce = SlideValue(headControl.RBHoldRotationMaxForce,initHeadHoldRotMaxForce,500000);					
			if ( physicsValuesAtTarget == true )
			{
				isResettingPhysics = false;
			}
		}

		private float SlideValue (float currentVal, float targetVal, float increment)
		{
			float newValue = currentVal;		
			if (currentVal < targetVal)
			{
				newValue = currentVal + increment ;
				if (newValue >= targetVal)
				{
					newValue = targetVal ;
				}
				else
				{
					physicsValuesAtTarget = false;
				}
			}
			if (currentVal > targetVal)
			{
				newValue = currentVal - increment;
				if (newValue <= targetVal)
				{
					newValue = targetVal ;
				}
				else
				{
					physicsValuesAtTarget = false;
				}
			}			
			return newValue ;
		}

		private void ToggleBJStart ()
		{
			if (isStarted == false )
			{
				StartBJMove () ;
			}
			else {TogglePauseBJMove () ;}				
		}
		
		private void TogglePauseBJMove ()
		{
			if (isPaused) {UnPauseBJMove();}
			else {PauseBJMove();}
		}
		
		private void PauseBJMove ()
		{
			if (isStarted)
			{
				pauseStartTime = Time.time ;
				isPaused = true ;
				isSettingPausePhysics = true ;
				startPauseButton.buttonText.text = "Unpause" ;
			}
		}
		
		private void UnPauseBJMove ()
		{
			if (isStarted)
			{
				isPaused = false ;
				if (isSettingPhysics == false && isResettingPhysics == false)
				{
					isResettingPausePhysics = true ;
				}
				isSettingPausePhysics = false ;
				startTime = startTime + (Time.time - pauseStartTime) ;
				lastFaceGrindHoldEndTime = lastFaceGrindHoldEndTime + (Time.time - pauseStartTime) ;
				faceGrindHoldStartTime = faceGrindHoldStartTime + (Time.time - pauseStartTime) ;
				startPauseButton.buttonText.text = "Pause" ;
			}
		}
        private void StartBJMove()
        {
			try
			{
				if (isStarted == false)
				{
					// Find first penis owner

					int count = SuperController.singleton.GetAtoms().Count(a => a.type == "Person"  && (a.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarlee") || a.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarjulian") || a.GetComponentInChildren<DAZCharacter>().name.StartsWith("male")) && a.uid != her.uid);
					if (count == 0){SuperController.LogMessage("BJ Assist could not identify a target character with a penis available in the scene.");}
					else
					{
						isPaused = false ;
						startPauseButton.buttonText.text = "Pause" ;
						him = SuperController.singleton.GetAtoms().First(a => a.category == "People"  && (a.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarlee") || a.GetComponentInChildren<DAZCharacter>().name.StartsWith("jarjulian") || a.GetComponentInChildren<DAZCharacter>().name.StartsWith("male")) && a.uid != her.uid);
						penisTip = him.freeControllers.First(fc => fc.name == "penisTipControl");
						penisBase = him.freeControllers.First(fc => fc.name == "penisBaseControl");
						penisMid = him.freeControllers.First(fc => fc.name == "penisMidControl");
						penisBaseRB = him.rigidbodies.First(rb => rb.name == "Gen3");
						isStarted = true;
						// Record initial controller states
						initPBPosState = penisBase.currentPositionState;
						initPBRotState = penisBase.currentRotationState ;
						initPMPosState = penisMid.currentPositionState;
						initPMRotState = penisMid.currentRotationState ;
						initPTPosState = penisTip.currentPositionState;
						initPTRotState = penisTip.currentRotationState ;
						initHeadPosState = headControl.currentPositionState ;
						initHeadRotState = headControl.currentRotationState;			
						// Set controller states
						penisBase.currentPositionState = FreeControllerV3.PositionState.On;
						penisBase.currentRotationState = FreeControllerV3.RotationState.On;
						penisMid.currentPositionState = FreeControllerV3.PositionState.Off;
						penisMid.currentRotationState = FreeControllerV3.RotationState.Off;
						penisTip.currentPositionState = FreeControllerV3.PositionState.Off;
						penisTip.currentRotationState = FreeControllerV3.RotationState.Off;
						headControl.currentPositionState = FreeControllerV3.PositionState.On;
						headControl.currentRotationState = FreeControllerV3.RotationState.On;						
						// Record initial head and penis physics values
						initPBHoldPosSpring = penisBase.RBHoldPositionSpring;
						initPBHoldRotSpring = penisBase.RBHoldRotationSpring;
						initPBHoldPosDamper = penisBase.RBHoldPositionDamper;
						initPBHoldRotDamper = penisBase.RBHoldRotationDamper;
						initPBHoldPosMaxForce = penisBase.RBHoldPositionMaxForce;
						initPBHoldRotMaxForce = penisBase.RBHoldRotationMaxForce;
						initPBJointRotSpring = penisBase.jointRotationDriveSpring;
						initPBJointRotDamper = penisBase.jointRotationDriveDamper;
						initPBJointRotMaxForce = penisBase.jointRotationDriveMaxForce;
						initPMJointRotSpring = penisMid.jointRotationDriveSpring;
						initPMJointRotDamper = penisMid.jointRotationDriveDamper;
						initPMJointRotMaxForce = penisMid.jointRotationDriveMaxForce;
						initPTJointRotSpring = penisTip.jointRotationDriveSpring;
						initPTJointRotDamper = penisTip.jointRotationDriveDamper;
						initPTJointRotMaxForce = penisTip.jointRotationDriveMaxForce;
						initHeadHoldPosSpring = headControl.RBHoldPositionSpring;
						initHeadHoldRotSpring = headControl.RBHoldRotationSpring;
						initHeadHoldPosDamper = headControl.RBHoldPositionDamper;
						initHeadHoldRotDamper = headControl.RBHoldRotationDamper;
						initHeadHoldPosMaxForce = headControl.RBHoldPositionMaxForce;
						initHeadHoldRotMaxForce = headControl.RBHoldRotationMaxForce;			
						if (enableHeadPenisPhysControl.val){isSettingPhysics = true ;isResettingPhysics = false ;isResettingPausePhysics = false;}
						headInitialPosition = headControl.transform.position;
						headInitialRotation = headControl.transform.rotation;
						headStartRotation = headInitialRotation;
						headInitialUp = headControl.transform.up ;
						penisBaseInitialPosition = penisBase.transform.position;
						penisBaseInitialUpDirection = penisBase.transform.up; 
						penisBaseInitialDirection = penisTip.transform.position - penisBase.transform.position;
						penisBaseStartRotation = penisBase.transform.rotation ;
						penisBaseToHeadTargetDirection = penisBaseInitialDirection ;
						MoveToPenisTip();
					}
				}
			}
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }				
        }		
		private void MoveToPenisTip ()
		{
			// Prepare for head move to just in front of penis
			headMoveTargetPosition = penisBaseInitialPosition + (penisBaseInitialDirection * 2.5f) ;
			journeyDistance = Vector3.Distance(headMoveTargetPosition, lipTrigger.transform.position);
			journeyTime = journeyDistance / headMoveToPenisSpeedJSON.val;
			startTime = Time.time;
			headStartRotation = headControl.transform.rotation;
			headInitialTargetRotationOffset = Quaternion.AngleAxis(headRotateInitialJSON.val,-penisBaseInitialDirection);
			headTargetRotation = Quaternion.LookRotation(-penisBaseInitialDirection, headInitialTargetRotationOffset *penisBaseInitialUpDirection) ;
			isSuckingOnPenis = false ;isSuckingOffPenis = false ;isMovingOnToPenis = false ;isFaceGrindHolding = false;isMovingToPenis = true;
		}
        private void MoveOnToPenis()
        {
            // Prepare for head move on to penis
			headMoveTargetPosition = penisBaseInitialPosition ;
            journeyDistance = Vector3.Distance(headMoveTargetPosition, lipTrigger.transform.position);
            journeyTime = journeyDistance / headMoveToPenisSpeedJSON.val;
            startTime = Time.time;
			lastFaceGrindHoldEndTime = Time.time;
            headTargetRotation = Quaternion.LookRotation(-penisBaseInitialDirection, penisBaseInitialUpDirection);
            isMovingToPenis = false; isMovingOnToPenis = true;
 		}
        private void StartSucking()
        {
            positionTarget = 1.5f - positionSuckStart.val;
			penisBaseNextDirection = penisTip.transform.position - penisBase.transform.position;
			headXTiltNext = 0;	headYTiltNext = 0;
			headZRotationTarget = headRotateMinMaxJSON.val ;
			headZRotationLastMinMaxTarget = headZRotationTarget ;
			headZRotationCurrent = AngleOffAroundAxis (headControl.transform.up, penisBaseInitialUpDirection, -penisBase.transform.forward) * Mathf.Rad2Deg ;
			headZRotationCurrent = 0f;
			isMovingOnToPenis = false;
            isSuckingOnPenis = true;
			positionCurrent = 0;				
			// Set the update  time step for sucking based on Suck Speed but limited by current Suck Depth (avoids shorty jittery sucks)
			// Speed is only changed once per suck cycle
			suckStep = Mathf.Min(headSuckSpeedJSON.val, positionSuckDepth.val) * Time.deltaTime;	
        }

		// Find some projected angle measure off some forward around some axis.
        public static float AngleOffAroundAxis(Vector3 v, Vector3 forward, Vector3 axis)
        {
            Vector3 right = Vector3.Cross(axis, forward);
            forward = Vector3.Cross(right, axis);
            Vector2 v2 = new Vector2(Vector3.Dot(v, forward), Vector3.Dot(v, right));
            v2.Normalize();
            return Mathf.Atan2(v2.y, v2.x);
        }
        private void StopBJ()
        {
			if (isStarted)
			{
				startTime = Time.time;
				headResetRotation = headControl.transform.rotation;
				penisResetRotation = penisBase.transform.rotation;
				isSuckingOffPenis = false; isSuckingOnPenis = false ; isMovingToPenis = false; isMovingOnToPenis = false; isResetting = true; isSettingPhysics = false ; isResettingPausePhysics = false;
				if (enableHeadPenisPhysControl.val == true ) {isResettingPhysics = true ; }
			}
        }
		// Updates the top and bottom suck positions and the target if the head has reached the top or bottom  suck positions
		// Also updates the speed based on UI if we have reached the suck top
		private void SetSuckPositionsAndSpeed ()
		{
			// Set face grinding throttle
			float faceGrindThrottle = 0f;					
			if (enableFaceGrind.val){faceGrindThrottle = faceGrindEnabled ;}
			else{faceGrindThrottle = faceGrindDisabled ;}
			
			// If the head has reached the top or bottom of suck positions on the penis then reverse direction of the suck
			if (positionTarget == positionTop)
			{					
				if (positionCurrent >= positionTop )
				{
					positionBottom = Mathf.Min( (Mathf.Max(1.5f - (positionSuckStart.val *1.5f) - (positionSuckDepth.val*1.5f), faceGrindThrottle) ), minPositionTwo);									
					positionTarget = positionBottom;					
					// Set the update  time step for sucking based on Suck Speed but limited by current Suck Depth (avoids short jittery sucks)
					// Speed is changed once per suck cycle
					suckStep = Mathf.Min(headSuckSpeedJSON.val, (positionTop - positionBottom)*2f) * Time.deltaTime;				
				}					
			}
			else
			{
				positionTarget = positionBottom ;
				if (isFaceGrindHolding && (Time.time-faceGrindHoldStartTime) >= faceGrindDurationJSON.val)
				{
					positionTop = Mathf.Max(1.5f - (positionSuckStart.val*1.5f), 0.2f) ;
					if (positionTop > 1.5f && positionTop < 2.2f){positionTop = 2.2f;}

					isFaceGrindHolding = false ;
					lastFaceGrindHoldEndTime = Time.time ;
					positionTarget = positionTop;
				}
				else if (isFaceGrindHolding)
				{
					positionTarget = faceGrindHold;
				}
				else if (positionCurrent <= positionBottom)
				{
					positionTop = Mathf.Max(1.5f - (positionSuckStart.val*1.5f), 0.2f) ;
					if (positionTop > 1.5f && positionTop < 2.2f){positionTop = 2.2f;}

					if (isFaceGrindHolding == false && (Time.time- lastFaceGrindHoldEndTime) >= faceGrindFrequencyJSON.val && enableFaceGrind.val == true && positionCurrent < faceGrindDisabled && faceGrindFrequencyJSON.val > 0f)
					{
						isFaceGrindHolding = true ;
						faceGrindHoldStartTime = Time.time ;
						positionTarget = faceGrindHold;
					}
					else if (isFaceGrindHolding == false) 
					{
						{
							positionTarget = positionTop;
						}
					}
				}						
			}
			// If suck speed is really slow (or stationary), then we allow it to be changed even if we are not at end of a suck cycle
			if (suckStep < 0.05f * Time.deltaTime )	{suckStep = Mathf.Min(headSuckSpeedJSON.val, (positionTop - positionBottom)*4f) * Time.deltaTime;}			
			// Gradually change the Position along the penis
			if (positionCurrent < positionTarget )
			{	
				positionCurrent = positionCurrent + (suckStep * 10 ) ;
				if (positionCurrent > positionTarget){ positionCurrent = positionTarget;}
			}
			else if (positionCurrent > positionTarget )
			{
				positionCurrent = positionCurrent - (suckStep * 10 ) ;	
				if (positionCurrent < positionTarget){ positionCurrent = positionTarget;}
			}
			if (isFaceGrindHolding && positionCurrent < faceGrindHold) {positionCurrent = faceGrindHold;}
		}
		private void UpdateHeadRotationTargets ()
		{			
			// Update the Target Z rotation of the Head if the Max or  Min values are changed in the UI
			if (headRotateMin != -headRotateMinMaxJSON.val )
			{
				if (headZRotationTarget == headRotateMin )
				{
					// Rotation Target should always be the Min or Max - so as Min has changed update the Target
					headZRotationTarget = -headRotateMinMaxJSON.val;
					headZRotationLastMinMaxTarget = headZRotationTarget;
				}
				headRotateMin = -headRotateMinMaxJSON.val;
			}					
			if (headRotateMax != headRotateMinMaxJSON.val )
			{
				if (headZRotationTarget == headRotateMax )
				{
					// Rotation Target should always be the Min or Max - so as Max has chaged update the Target
					headZRotationTarget = headRotateMinMaxJSON.val;
					headZRotationLastMinMaxTarget = headZRotationTarget;
				}
				headRotateMax = headRotateMinMaxJSON.val;
			}
			// Set new target for Z head rotation (rotation around penis length) if reached max or min limits
			if (headZRotationCurrent < Mathf.Min(headRotateMin,headRotateMax) )
			{
				headZRotationTarget = Mathf.Max(headRotateMin, headRotateMax) ;
				headZRotationLastMinMaxTarget = headZRotationTarget;
			}
			else if (headZRotationCurrent > Mathf.Max(headRotateMin, headRotateMax)) 
			{
				headZRotationTarget = Mathf.Min(headRotateMin, headRotateMax) ;
				headZRotationLastMinMaxTarget = headZRotationTarget;
			}
			else if (headZRotationTarget != headRotateMin && headZRotationTarget != headRotateMax)
			{
				headZRotationTarget = headZRotationLastMinMaxTarget ;
			}			
		}			
		private void UpdateHeadTiltAndRotation ()
		{
			// Gradually change the head  rotation towards the target rotation
			if (headZRotationTarget < headZRotationCurrent){headZRotationCurrent = headZRotationCurrent - (rotateHeadStep * 50) ;}
			else{headZRotationCurrent = headZRotationCurrent + (rotateHeadStep * 50);}				

			// Gradually change the Y head tilt towards target tilt
			if (headYTiltTarget < headYTiltNext ){headYTiltNext = headYTiltNext - (tiltHeadStep * 50) ;	}
			else if (headYTiltTarget > headYTiltNext){headYTiltNext = headYTiltNext + (tiltHeadStep * 50) ;}					
			// Gradually change the X head tilt towards target tilt
			if (headXTiltTarget < headXTiltNext ){headXTiltNext = headXTiltNext - (tiltHeadStep * 50) ;	}
			else if (headXTiltTarget > headXTiltNext){headXTiltNext = headXTiltNext + (tiltHeadStep * 50) ;	}
		}
		private void UpdateHeadMoveSpeeds ()
		{		
			// Set the update time step for moving the head
			moveHeadStep = headMoveSpeedJSON.val * Time.deltaTime;
			// Set the update time step for head tilt
			if (isSuckingOnPenis){tiltHeadStep =  headTiltSpeedJSON.val * Time.deltaTime;}
			else if (isSuckingOffPenis){tiltHeadStep = (journeyDistance / journeyTime) /20 ;}			
			// Set the update time step for head rotation based on Rotation Speed but throttled by Rotation Angle range (avoids small jittery rotations)
			// However if the current head rotation is outside the min and max rotation boundaries (e.g. at BJ start) then we dont what to throttle rotation speed
			if (headZRotationCurrent < Mathf.Min (headRotateMin,headRotateMax) || headZRotationCurrent > Mathf.Max (headRotateMin,headRotateMax))
			{
				// The current head rotation is outside of Rotation Min and Max, so we set the speed without throttling it
				rotateHeadStep = headRotateSpeedJSON.val * Time.deltaTime;
			}
			else
			{
				// Set head rotation speed, but throttle it proportional to the Max to Min Rotation angle range
				rotateHeadStep = Mathf.Min(headRotateSpeedJSON.val, (Mathf.Max(headRotateMin,headRotateMax) - Mathf.Min (headRotateMin,headRotateMax))/10) * Time.deltaTime;
			}			
		}		
		private void SetHeadToLipOffset()
        {
			headToLipOffset = headRigidbody.transform.position - lipTrigger.transform.position ;
		}

        private void PenisLookAtLip()
        {
            penisBase.transform.LookAt(lipTrigger.transform.position, penisBaseInitialUpDirection);
        }
        private void ToggleLipMorphs()
        {
            if (!enableLipMorphs.val){lipMorphsDisabling=true;}
        }
        private void LipMorphsEnable()
        {
            if (enableLipMorphs.val)
            {
                foreach (KeyValuePair<DAZMorph, float> morphPair in LipMorphs)
                {
					if (morphPair.Key.morphValue > morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue - TongueMorphIncrement ;
						if (morphPair.Key.morphValue < morphPair.Value){morphPair.Key.morphValue = morphPair.Value ;}
					}
					else if (morphPair.Key.morphValue < morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue + TongueMorphIncrement ;
						if (morphPair.Key.morphValue > morphPair.Value){morphPair.Key.morphValue = morphPair.Value ;}						
					}
                }
            }
        }
        private void LipMorphsReset()
        {
            if (enableLipMorphs.val || lipMorphsDisabling)
            {
				foreach (KeyValuePair<DAZMorph, float> morphPair in LipMorphs)
				{
					if (morphPair.Key.morphValue < 0)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue + TongueMorphIncrement ;
						if (morphPair.Key.morphValue > 0){morphPair.Key.morphValue = 0 ;lipMorphsDisabling=false; }
					}
					else if (morphPair.Key.morphValue > 0)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue - TongueMorphIncrement ;
						if (morphPair.Key.morphValue < 0){morphPair.Key.morphValue = 0 ;lipMorphsDisabling=false; }						
					}
				}
			}
        }
		private void ToggleTongueMorphs()
		{
			if (enableTongueMorphs.val == false)  {tongueMorphTwist.morphValue = 0f ;	tongueMorphSideSide.morphValue = 0f ; tongueMorphBendTip.morphValue = 0f ;tongueMorphsDisabling = true;}
		}
        private void TongueMorphsEnable()
        {
            if (enableTongueMorphs.val)
            {
                foreach (KeyValuePair<DAZMorph, float> morphPair in TongueOutMorphs)
                {
					if (morphPair.Key.morphValue > morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue - TongueMorphIncrement ;
						if (morphPair.Key.morphValue < morphPair.Value){morphPair.Key.morphValue = morphPair.Value ;}
					}
					else if (morphPair.Key.morphValue < morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue + TongueMorphIncrement ;
						if (morphPair.Key.morphValue > morphPair.Value){morphPair.Key.morphValue = morphPair.Value ;}					
					}
                }
            }
        }
        private void TongueMorphsReset()
        {
            if (enableTongueMorphs.val || tongueMorphsDisabling)
            {
				foreach (KeyValuePair<DAZMorph, float> morphPair in TongueInMorphs)
				{
					if (morphPair.Key.morphValue < morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue + TongueMorphIncrement ;
						if (morphPair.Key.morphValue > morphPair.Value)	{morphPair.Key.morphValue = morphPair.Value; tongueMorphsDisabling=false; }
					}
					else if (morphPair.Key.morphValue > morphPair.Value)
					{
						morphPair.Key.morphValue = morphPair.Key.morphValue - TongueMorphIncrement ;
						if (morphPair.Key.morphValue < morphPair.Value) {morphPair.Key.morphValue = morphPair.Value ; tongueMorphsDisabling=false;}						
					}
				}
			}
        }	
	    public static float DistanceToNearestPointOnFiniteLine(Vector3 start, Vector3 end, Vector3 pnt)
		{
			var line = (end - start);
			var len = line.magnitude;
			line.Normalize();		   
			var v = pnt - start;
			var d = Vector3.Dot(v, line);
			d = Mathf.Clamp(d, 0f, len);
			float distance = Vector3.Distance(pnt,start + (line * d)) ;
			return distance;
		}
       // OnDestroy is where you should put any cleanup if you registered objects to supercontroller or atom, you should unregister them here
//       void OnDestroy(){}	
	}
}